this.name           = "swarm_seeker";
this.author         = "Thargoid";
this.copyright		= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description    = "Ship script for the Thargoid swarm seeker";
this.version        = "1.03";
"use strict";

this.shipSpawned = function()
	{ 	
	this.spawnedTime = clock.absoluteSeconds;
	function targetShips(entity) {return entity.isShip && entity.isValid && entity.isCloaked && !entity.hasRole("thargoid") && entity.scanClass !== "CLASS_THARGOID" && !entity.isThargoid}; 
	this.cloakedShips = system.filteredEntities(this, targetShips, this.ship, 25600); 
	
	if(this.cloakedShips.length === 0)
		{ 
		this.ship.explode();
		return;
		}
	
	this.victim = this.cloakedShips[0];
	this.callbackID = addFrameCallback(this.trackVictim.bind(this)); 
	};
	
this.trackVictim = function()
	{
	if(!this.victim || !this.victim.isValid || (clock.absoluteSeconds - this.spawnedTime > 120))
		{
		this.stopCallback();
		this.ship.explode();
		return;
		}
		
	var targetVector = this.victim.position.subtract(this.ship.position).direction();
	var angle = this.ship.heading.angleTo(targetVector);
	var cross = this.ship.heading.cross(targetVector).direction();
	this.ship.orientation = this.ship.orientation.rotate(cross, -angle);	
	this.ship.desiredSpeed = this.ship.maxSpeed;
	
	if(this.ship && this.victim && (this.ship.position.distanceTo(this.victim.position) < 25))
		{
		if(this.victim && this.victim.isValid && this.victim.equipmentStatus("EQ_CLOAKING_DEVICE", "EQUIPMENT_OK"))
			{
			if(Math.random() > 0.9)
				{ this.victim.setEquipmentStatus("EQ_CLOAKING_DEVICE", "EQUIPMENT_DAMAGED"); }
			else
				{
				this.victim.removeEquipment("EQ_CLOAKING_DEVICE");
				this.victim.awardEquipment("EQ_CLOAKING_DEVICE");
				}
			}	
		this.stopCallback(); 
		}
	};

this.shipDied = this.stopCallback = function()
	{
	if(this.callbackID && isValidFrameCallback(this.callbackID)) 
		{ removeFrameCallback(this.callbackID); } 
	delete this.callbackID;
	};
	
this.shipHitByECM = function(pulse)
	{
	if(Math.random() < ((pulse+1)/100))
		{ 
		this.stopCallback();
		this.ship.explode();
		}
	};